unit fMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WordReport, DB, IBCustomDataSet, IBQuery, IBDatabase,
  ComCtrls;

type
  TForm1 = class(TForm)
    WordReport1: TWordReport;
    IBDB: TIBDatabase;
    RTransact: TIBTransaction;
    QWillages: TIBQuery;
    Query1: TIBQuery;
    QTotals: TIBQuery;
    SaveDlg: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    DateTimePicker1: TDateTimePicker;
    Button2: TButton;
    TabSheet2: TTabSheet;
    Button1: TButton;
    Label4: TLabel;
    DateTimePicker2: TDateTimePicker;
    Label5: TLabel;
    DateTimePicker3: TDateTimePicker;
    procedure Button2Click(Sender: TObject);
    procedure WordReport1ReadMaket1(Sender: TObject);
    procedure WordReport1ReadMaket2(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    function GetProgramRootPath: string;
    function dbConnect(dbFileName,Usr,Pass:string):boolean;
    procedure FillWillages;
    procedure getPersonLandsList(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
    procedure getLandsTotal(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
    procedure getContractsList(Date1,Date2:TDateTime);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  StrUtils, DateUtils;

function TForm1.dbConnect(dbFileName,Usr,Pass:string):boolean;
begin
  with IBDB do begin
    DataBaseName:=dbFileName;
    Params.Clear;
    Params.Add('lc_ctype=WIN1251');
    Params.Add('user_name='+Usr);
    Params.Add('password='+Pass);
    Params.Add('sql_role_name=RDB$ADMIN');
    LoginPrompt:=false;
  end;
  try
    IBDB.Open;
  except
    on E:EDatabaseError do begin
      MessageDlg('    : '+E.Message,mtError,[mbOK],0);
      Result:=false;
      Exit;
    end;
  end;
  Result:=IBDB.Connected;
end;

procedure TForm1.FillWillages;
begin
  QWillages.Close;
  ComboBox1.Items.Clear;
  ComboBox1.Items.Add('');
  with QWillages do begin
    SQL.Text:=
      'SELECT id_willage, w_name FROM tz_willages;';
    Open; First;
    while not Eof do begin
      ComboBox1.Items.Add(FieldByName('W_NAME').AsString);
      Next;
    end;
  end;
  ComboBox1.ItemIndex:=0;
end;

procedure TForm1.getContractsList(Date1,Date2:TDateTime);
begin
  Query1.Close;
  Query1.SQL.Text:=
    'SELECT '+
    '  c_number, p_name, c_odate, c_cdate, tbalance '+
    'FROM vt_contracts '+
    'WHERE c_odate>='+#39+DateToStr(Date1)+#39+' and c_odate<='+#39+DateToStr(Date2)+#39+';';
  Query1.Open;
end;

procedure TForm1.getPersonLandsList(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
var
  Cond1,Cond2,Cond3: string;
begin
  Query1.Close;
  Cond1:='rs_year='+IntToStr(YearOf(EndDate))+' AND c_odate<='+#39+DateToStr(EndDate)+#39;
  if WillageID>0 then Cond2:=' AND id_willage='+IntToStr(WillageID) else Cond2:='';
  if PersonType<>0 then Cond3:=' AND p_is_org='+IntToStr(PersonType-1) else Cond3:='';
  Query1.SQL.Text:=
    'SELECT '+
    '  id_contract, grid, p_name, p_adress, tadd, tsub, a_adress, a_size, ut_name, ut_kkorr '+
    'FROM vt_persons_lands '+
    'WHERE '+Cond1+Cond2+Cond3+';';
  Query1.Open;
end;

procedure TForm1.getLandsTotal(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
var
  Cond1,Cond2,Cond3: string;
begin
  QTotals.Close;
  Cond1:='rs_year='+IntToStr(YearOf(EndDate));
  if WillageID>0 then Cond2:=' AND id_willage='+IntToStr(WillageID) else Cond2:='';
  if PersonType<>0 then Cond3:=' AND p_is_org='+IntToStr(PersonType-1) else Cond3:='';
  QTotals.SQL.Text:=
    'SELECT '+
    '  ut_name, zcount, ssize, tadd, tsub '+
    'FROM vt_lands_totals '+
    'WHERE '+Cond1+Cond2+Cond3+';';
  QTotals.Open;
end;

function TForm1.GetProgramRootPath: string;
var cPath: string;
begin
  cPath:=ParamStr(0);
  cPath:=LeftStr(cPath,Length(cPath)-17);
  Result:=cPath;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if not SaveDlg.Execute then Exit;
  WordReport1.ResultDocFileName:=SaveDlg.FileName;
  case (Sender as TComponent).Tag of
    1: with WordReport1 do begin
      TemplateDocFileName:=GetProgramRootPath+'template\.doc';
      OnReadMaket:=WordReport1ReadMaket1;
    end;
    2: with WordReport1 do begin
      TemplateDocFileName:=GetProgramRootPath+'template\.doc';
      OnReadMaket:=WordReport1ReadMaket2;
    end;
  end;
  try WordReport1.Build; finally
    if WordReport1.ShowResult then WindowState:=wsMinimized;
    WordReport1.Quit;
  end;
end;

//      -,
// .. ,     (bands)    , 
//           ().
// ,     :
// 1.     ,
// 2.     ,
// 3.         .

procedure TForm1.WordReport1ReadMaket1(Sender: TObject);
var
  WillageID: Integer;
  RDate: TDateTime;
  PersonType: Byte;
  PType1,PType2,WillageName: string;
begin
  WillageID:=Combobox1.ItemIndex;
  WillageName:=Combobox1.Items.Strings[Combobox1.ItemIndex];
  RDate:=DateTimePicker1.Date;
  PersonType:=ComboBox2.ItemIndex;

  //   .

  getPersonLandsList(WillageID,RDate,PersonType);
  getLandsTotal(WillageID,RDate,PersonType);

  case PersonType of
    0: begin
      PType1:='';
      PType2:='';
    end;
    1: begin
      PType1:=' -';
      PType2:='  ';
    end;
    2: begin
      PType1:=' -';
      PType2:='  ';
    end;
  end;

  //    .
  // .. ,         .

  with WordReport1 do begin
    if WillageID>0 then begin
      SetValue('Willage','  '+WillageName);
    end else
      SetValue('Willage','');
    SetValue('curDate',DateToStr(RDate));
    SetValue('curYear',YearOf(RDate));
    SetValue('Person.TypeA',PType1);
    SetValue('Person.TypeB',PType2);
  end;

  //      ,
  //          
  // (     .   SysUtils.Format)

  //  R

  if WordReport1.BandExists('R') then
    with WordReport1.Bands['R'] do begin
      AssignDataSet(@Query1);
      SetField('Name','P_NAME','');
      SetField('Adress','P_ADRESS','');
      SetField('tadd','TADD','%10.2f');
      SetField('tsub','TSUB','%10.2f');
    end;

    //  

    if WordReport1.BandExists('A') then
      with WordReport1.Bands['A'] do begin
        AssignDataSet(@Query1);
        SetField('Adress','A_ADRESS','');
        SetField('s','A_SIZE','');
        SetField('UseType','UT_NAME','');
        SetField('kk','UT_KKORR','%8.6g');
      end;

  //  ,      :
  //            .
  // ,        ,
  //     ,     
  //   .

  // :     'R'  'A',   'GRID'
  //   .  :  GRID=0 -     R,  
  // GRID=1 -   A.

  WordReport1.JoinBands('GRID','R',0,'A',1);

  // p.s.          (union)

  //  T

  if WordReport1.BandExists('T') then
    with WordReport1.Bands['T'] do begin
      AssignDataSet(@QTotals);
      SetField('UseType','UT_NAME','');
      SetField('ACount','ZCOUNT','');
      SetField('S','SSIZE','');
      SetField('tadd','TADD','%10.2f');
      SetField('tsub','TSUB','%10.2f');
    end;
end;

//   2 - 

procedure TForm1.WordReport1ReadMaket2(Sender: TObject);
begin
  getContractsList(DateTimePicker2.Date,DateTimePicker3.Date);

  with WordReport1 do begin
    SetValue('Rdate1',DateToStr(DateTimePicker2.Date));
    SetValue('Rdate2',DateToStr(DateTimePicker3.Date));
  end;

  //  C

  if WordReport1.BandExists('C') then
    with WordReport1.Bands['C'] do begin
      AssignDataSet(@Query1);
      SetField('num','C_NUMBER','');
      SetField('name','P_NAME','');
      SetField('odate','C_ODATE','');
      SetField('cdate','C_CDATE','');
      SetField('balance','TBALANCE','%10.2f');
    end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  dbConnect(GetProgramRootPath+'db\zu_kineshma.fdb','IS_USER','111111');
  FillWillages;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  IBDB.Close;
end;

end.
