procedure TForm1.getContractsList(Date1,Date2:TDateTime);
begin
  Query1.Close;
  Query1.SQL.Text:=
    'SELECT '+
    '  c_number, p_name, c_odate, c_cdate, tbalance '+
    'FROM vt_contracts '+
    'WHERE c_odate>='+#39+DateToStr(Date1)+#39+' and c_odate<='+#39+DateToStr(Date2)+#39+';';
  Query1.Open;
end;

procedure TForm1.getPersonLandsList(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
var
  Cond1,Cond2,Cond3: string;
begin
  Query1.Close;
  Cond1:='rs_year='+IntToStr(YearOf(EndDate))+' AND c_odate<='+#39+DateToStr(EndDate)+#39;
  if WillageID>0 then Cond2:=' AND id_willage='+IntToStr(WillageID) else Cond2:='';
  if PersonType<>0 then Cond3:=' AND p_is_org='+IntToStr(PersonType-1) else Cond3:='';
  Query1.SQL.Text:=
    'SELECT '+
    '  id_contract, grid, p_name, p_adress, tadd, tsub, a_adress, a_size, ut_name, ut_kkorr '+
    'FROM vt_persons_lands '+
    'WHERE '+Cond1+Cond2+Cond3+';';
  Query1.Open;
end;

procedure TForm1.getLandsTotal(WillageID:integer; EndDate: TDateTime; PersonType:Byte);
var
  Cond1,Cond2,Cond3: string;
begin
  QTotals.Close;
  Cond1:='rs_year='+IntToStr(YearOf(EndDate));
  if WillageID>0 then Cond2:=' AND id_willage='+IntToStr(WillageID) else Cond2:='';
  if PersonType<>0 then Cond3:=' AND p_is_org='+IntToStr(PersonType-1) else Cond3:='';
  QTotals.SQL.Text:=
    'SELECT '+
    '  ut_name, zcount, ssize, tadd, tsub '+
    'FROM vt_lands_totals '+
    'WHERE '+Cond1+Cond2+Cond3+';';
  QTotals.Open;
end;

//      -,
// .. ,     (bands)    , 
//           ().
// ,     :
// 1.     ,
// 2.     ,
// 3.         .

procedure TForm1.WordReport1ReadMaket1(Sender: TObject);
var
  WillageID: Integer;
  RDate: TDateTime;
  PersonType: Byte;
  PType1,PType2,WillageName: string;
begin
  WillageID:=Combobox1.ItemIndex;
  WillageName:=Combobox1.Items.Strings[Combobox1.ItemIndex];
  RDate:=DateTimePicker1.Date;
  PersonType:=ComboBox2.ItemIndex;

  //   .

  getPersonLandsList(WillageID,RDate,PersonType);
  getLandsTotal(WillageID,RDate,PersonType);

  case PersonType of
    0: begin
      PType1:='';
      PType2:='';
    end;
    1: begin
      PType1:=' -';
      PType2:='  ';
    end;
    2: begin
      PType1:=' -';
      PType2:='  ';
    end;
  end;

  //    .
  // .. ,         .

  with WordReport1 do begin
    if WillageID>0 then begin
      SetValue('Willage','  '+WillageName);
    end else
      SetValue('Willage','');
    SetValue('curDate',DateToStr(RDate));
    SetValue('curYear',YearOf(RDate));
    SetValue('Person.TypeA',PType1);
    SetValue('Person.TypeB',PType2);
  end;

  //      ,
  //          
  // (     .   SysUtils.Format)

  //  R

  if WordReport1.BandExists('R') then
    with WordReport1.Bands['R'] do begin
      AssignDataSet(@Query1);
      SetField('Name','P_NAME','');
      SetField('Adress','P_ADRESS','');
      SetField('tadd','TADD','%10.2f');
      SetField('tsub','TSUB','%10.2f');
    end;

    //  

    if WordReport1.BandExists('A') then
      with WordReport1.Bands['A'] do begin
        AssignDataSet(@Query1);
        SetField('Adress','A_ADRESS','');
        SetField('s','A_SIZE','');
        SetField('UseType','UT_NAME','');
        SetField('kk','UT_KKORR','%8.6g');
      end;

  //  ,      :
  //            .
  // ,        ,
  //     ,     
  //   .

  // :     'R'  'A',   'GRID'
  //   .  :  GRID=0 -     R,  
  // GRID=1 -   A.

  WordReport1.JoinBands('GRID','R',0,'A',1);

  // p.s.          (union)

  //  T

  if WordReport1.BandExists('T') then
    with WordReport1.Bands['T'] do begin
      AssignDataSet(@QTotals);
      SetField('UseType','UT_NAME','');
      SetField('ACount','ZCOUNT','');
      SetField('S','SSIZE','');
      SetField('tadd','TADD','%10.2f');
      SetField('tsub','TSUB','%10.2f');
    end;
end;